/*************************************************************************\
 * Copyright (c) 2002 The University of Chicago, as Operator of Argonne
 *     National Laboratory.
 * Copyright (c) 2002 The Regents of the University of California, as
 *     Operator of Los Alamos National Laboratory.
 * EPICS BASE Versions 3.13.7
 * and higher are distributed subject to a Software License Agreement found
 * in file LICENSE that is included with this distribution. 
\*************************************************************************/

#ifndef SearchDest_h
#define SearchDest_h

#include "tsDLList.h"

class channelNode;
typedef epics :: Mutex :: Guard Guard;

struct SearchDest :
    public tsDLNode < SearchDest > {
    virtual ~SearchDest () {};
    struct Callback {
        virtual ~Callback () {};
        virtual void notify (
            const caHdr & msg, const void * pPayload,
            const osiSockAddr & addr, const epicsTime & ) = 0;
        virtual void show ( 
            Guard &, unsigned level ) const = 0;
    };
    virtual void searchRequest ( Guard &,
        const char * pbuf, size_t len ) = 0;
    virtual void show ( Guard &, unsigned level ) const = 0;
};

#endif // SearchDest_h
