/*************************************************************************\
* Copyright (c) 2002 The University of Chicago, as Operator of Argonne
*     National Laboratory.
* Copyright (c) 2002 The Regents of the University of California, as
*     Operator of Los Alamos National Laboratory.
* EPICS BASE Versions 3.13.7
* and higher are distributed subject to a Software License Agreement found
* in file LICENSE that is included with this distribution. 
\*************************************************************************/
/*  
 *  noopiiu.h,v 1.7 2009/09/10 16:10:17 jhill Exp
 *
 *                              
 *                    L O S  A L A M O S
 *              Los Alamos National Laboratory
 *               Los Alamos, New Mexico 87545
 *                                  
 *  Copyright, 1986, The Regents of the University of California.
 *                                  
 *           
 *	Author Jeffrey O. Hill
 *	johill@lanl.gov
 *	505 665 1831
 */

#ifndef noopiiuh
#define noopiiuh

#include "netiiu.h"

class noopiiu : public netiiu {
public:
    ~noopiiu ();
    void hostName ( 
        Guard &, char * pBuf, 
        unsigned bufLength ) const;
    const char * pHostName (
        Guard & ) const throw (); 
    unsigned getHostName (
        Guard &, 
        char * pBuf, unsigned bufLen ) const throw ();
    bool ca_v41_ok (
        Guard & ) const;
    bool ca_v42_ok (
        Guard & ) const;
    size_t requestMessageBytesPending ( 
        Guard & mutualExclusionGuard );
    void flush ( 
        Guard & mutualExclusionGuard );
    void writeRequest ( 
        Guard &, nciu &, 
        unsigned type, arrayElementCount nElem, 
        const void *pValue );
    void writeNotifyRequest ( 
        Guard &, 
        nciu &, netWriteNotifyIO &, 
        unsigned type, arrayElementCount nElem, 
        const void *pValue );
    void readNotifyRequest ( 
        Guard &, nciu &, 
        netReadNotifyIO &, unsigned type, 
        arrayElementCount nElem );
    void clearChannelRequest ( 
        Guard &, 
        ca_uint32_t sid, ca_uint32_t cid );
    void subscriptionRequest ( 
        Guard &, 
        nciu &, netSubscription & );
    void subscriptionUpdateRequest ( 
        Guard &, 
        nciu &, netSubscription & );
    void subscriptionCancelRequest ( 
        Guard &, 
        nciu & chan, netSubscription & subscr );
    void flushRequest ( 
        Guard & );
    void requestRecvProcessPostponedFlush (
        Guard & );
    osiSockAddr getNetworkAddress (
        Guard & ) const;
    void uninstallChan ( 
        Guard & mutex, 
        nciu & );
    void uninstallChanDueToSuccessfulSearchResponse ( 
        Guard &, nciu &, 
        const class epicsTime & currentTime );
    double receiveWatchdogDelay (
        Guard & ) const;
    bool searchMsg (
        Guard &, ca_uint32_t id, 
            const char * pName, unsigned nameLength );
};

extern noopiiu noopIIU;

#endif // ifndef noopiiuh
