/*
 *	Author Jeffrey O. Hill
 *	johill@lanl.gov
 */

#include "daIdent.h"
#include "daCatalogSingle.h"

#define epicsExportSharedSymbols
#include "caNetAddr.h"
#include "caChannelAddress.h"

namespace ca {

ChannelAddress :: ChannelAddress ()
{
}

void ChannelAddress :: 
    traverse ( Introspector & introspector ) const
{
    InetAddrV4Catalog inetAddrV4 ( 0, 0 );
    CatalogSingle < ID_internetV4, Catalog & > netAddr ( inetAddrV4 );
    introspector.reveal ( pi_networkAddress, netAddr );
}

void ChannelAddress :: 
    find ( const Ident & id, Viewer & viewer ) const
{
    if ( id == pi_networkAddress ) {
        InetAddrV4Catalog inetAddrV4 ( 0, 0 );
        CatalogSingle < ID_internetV4, Catalog & > netAddr ( inetAddrV4 );
        viewer.reveal ( netAddr );
    }
}

} // end of namespace ca
