
/*
 *	Author Jeffrey O. Hill
 *	johill@lanl.gov
 */

#error defunct?

#define epicsExportSharedSymbols
#include "caSvrCirMgr.h"
#include "caSvrCirMgrChan.h"

namespace ca {

//
// Issues
// ------
// 1) What do we do if the service keeps a reference to the 
// m_handleResponderService in the Chan :: Req after the Chan has 
// been deleted. What do we do if the service keeps a reference 
// to the Chan :: Req after either of the CirSvr or the Server 
// are deleted. ANSWER: There is an assert fail in ~Req if they
// continue to hold a reference
//

#if 0
CirSvr :: Chan :: Req :: 
    Req ( Chan & chan, ReqNotify & notify, RefCtr & refCtr ) :
    m_notify ( notify ), 
    m_chan ( chan ),
    m_refCtr ( refCtr )
{ 
    m_chan.m_reqList.add ( *this );
}

CirSvr :: Chan :: Req :: 
    ~Req ()
{
    if ( ! m_pRequest.isNill () ) {
        {
            // deadlock prevention
            Mutex :: Unlocker 
                unlocker ( m_chan.m_cirSvr.m_mutex );
            m_pRequest->cancel ();
        }
        // we check again in case they called
        // back when the lock was release -
        // and possibly as a side effect of 
        // cancel
        if ( ! m_pRequest.isNill () ) {
            m_pRequest.clear ();
            m_chan.m_reqList.remove ( *this );
        }
    }
    // there will be an assert fail in m_refCtr at
    // this point in the execution if they fail to
    // destroy all references to the response when 
    // the IO is canceled, or completed
}

#if 0
void CirSvr :: Chan :: Req ::
    initiate ( PReq & pReq, PResp & pEventQueueResp )
{
    assert ( ! pEventQueueResp.isNill () );
    assert ( m_pEventQueueResp.isNill () );
    m_pEventQueueResp = pEventQueueResp;
    assert ( m_pReq.isNill () );
    assert ( ! pReq.isNill () );
    m_pReq = pReq;
#error deadlock potential 
    pReq->initiate ( PResp ( m_handleResponderService ) );
}

void CirSvr :: Chan :: Req ::
    initiate ( PReq & pReq, PResp & pEventQueueResp, PCat & pCat )
{
    assert ( ! pEventQueueResp.isNill () );
    assert ( m_pEventQueueResp.isNill () );
    m_pEventQueueResp = pEventQueueResp;
    assert ( m_pReq.isNill () );
    assert ( ! pReq.isNill () );
    m_pReq = pReq;
#error deadlock potential 
    pReq->initiate ( PResp ( m_handleResponderService ), pCat );
}
#endif

void CirSvr :: Chan :: Req :: 
    forceFailResponse ( PResp &, const std :: string & failCtx )
{
#pragma message ("it appears that this is always called when the reques need not be canceled")
#pragma message ("but there is a strong possibility of mistakes")
    m_chan.m_cirSvr.m_eventQueue.postFailure ( m_pEventQueueResp, failCtx );
    m_pRequest.clear ();
    m_pEventQueueResp.clear ();
}

void CirSvr :: Chan :: Req ::
    show ( unsigned level ) const
{
    printf ( "CirSvr :: Chan :: Req:\n" );
    if ( level > 0 ) {
        m_notify.show ( level - 1 );
    }
}

#error
void  CirSvr :: Chan :: Req :: 
    channelDestroyNotify ()
{ 
    if ( ! m_pRequest.isNill () ) {
        {
            // deadlock prevention
            Mutex :: Unlocker 
                unlocker ( m_chan.m_cirSvr.m_mutex );
            m_pRequest->cancel ();
        }
        m_pRequest.clear ();
    }
}

void CirSvr :: Chan :: Req :: ResponderService :: 
    m_responseNotify ( const PCat & pCat )
{
    EnclBinding :: Ptr < Req > pReq ( *this );
    pReq->m_chan.m_cirSvr.m_eventQueue.
        post ( pReq->m_pEventQueueResp, pCat );
    pReq->m_pRequest.clear ();
    pReq->m_pEventQueueResp.clear ();
}

bool CirSvr :: Chan :: Req :: 
    subscrDestroy ( caResId resId )
{ 
    return m_notify.subscrDestroy ( resId );
}

void CirSvr :: Chan :: Req :: 
    readLackingCallbackDestroy ()
{
    return m_notify.readLackingCallbackDestroy ();
}

void CirSvr :: Chan :: Req :: 
    enterFlowControlMode ()
{ 
    m_notify.enterFlowControlMode ();
}

void CirSvr :: Chan :: Req :: 
    exitFlowControlMode ()
{ 
    m_notify.exitFlowControlMode ();
}

Responder & 
    CirSvr :: Chan :: Req :: HandleResponderService :: 
        lock ()
{
    EnclBinding :: Ptr < Req > pReq ( *this );
    pReq->m_chan.m_cirSvr.m_mutex.lock ();
    return pReq->m_responderService;
}

Responder & 
    CirSvr :: Chan :: Req :: HandleResponderService :: 
        lockRecursive ()
{
    EnclBinding :: Ptr < Req > pReq ( *this );
    pReq->m_chan.m_cirSvr.m_mutex.lockRecursive ();
    return pReq->m_responderService;
}

void CirSvr :: Chan :: Req :: HandleResponderService :: 
    unlock ()
{
    EnclBinding :: Ptr < Req > pReq ( *this );
    pReq->m_chan.m_cirSvr.m_mutex.unlock ();
}

HandleIntf < Responder > & 
    CirSvr :: Chan :: Req :: HandleResponderService :: 
        clone ()
{
    EnclBinding :: Ptr < Req > pReq ( *this );
    pReq->m_refCtr.reference ();
    return pReq->m_handleResponderService;
}
#endif

#if 0
void CirSvr :: Chan :: Req :: HandleResponderService :: 
    release ()
{
    EnclBinding :: Ptr < Req > pReq ( *this );
    if ( pReq->m_refCtr.unreference () ) {
#error 
    }
}
#endif

} // end of namespace ca
