
#include "FailureContext.h"
#include "casdef2.h"

namespace ca {

FailureContext ::
    FailureContext ( const char * pCtxString ) :
    m_ctxString ( pCtxString )
{
}

void FailureContext ::
    traverse ( Introspector & introspector ) const
{
    introspector.reveal ( Responder :: context, m_ctxString );
}

void FailureContext ::
    find ( const Ident & id, Viewer & viewer ) const
{
    if ( id == Responder :: context ) {
        viewer.reveal ( m_ctxString );
    }
}

} // end of namespace ca
