




class OctetStreamDBR {
public:
    // this class is synchronized with the same Mutex 
    // that the PBuf :: Locker being passed to the ctor uses
    // 
    Snipet {
    public:
        typedef Ptr < const epicsUInt8 > PBuf;
        Snipet ( PBuf :: Locker &, size_t offset, size_t length );
        PBuf :: Locker makePtrLocker ();
        OctetStreamSnipet * pNext ();
    private:
        class Handler : 
            public HandlerAbstract < const epicsUInt8 > {
        public:
            Mutex & mutex ();
            ElementBlock < const epicsUInt8 > target ( const Guard & ) const;
            void release ( const Guard & );
        };
        PBuf m_pSeg;
        size_t m_offset;
        size_t m_length;
        Mutex m_mutex;
        Handler m_handler;
        OctetStreamSnipet * m_pNext;
    };

    OctetStreamDBR ();
private:
    typedef RefCtr < const epicsUInt8, 
        HandleAbstract < const epicsUInt8 > > M_RefCtr;

#error some immediate issues
    // Issues:
    // 1) somehow this class needs to know how to implement the
    // Catalog for the DBR type. Since, for writes, this is 
    // scalar and vector types, but not compound types then the
    // job is perhaps easier. 
    // => one possibility would be to precreate this object for
    // the protocol payload, and later in the protocol stub embue
    // the object with a Catalog reference that knows what to do.
    // 2) The Catalog will need an iterator with these features
    // a) It needs to fetch out the primitive types
    // b) hide segmented buffering
    // c) throw an exception when past the end of the payload
    // d) fast skip forward by NNN bytes (to implement find).
    // This is actually not currently needed. It will be needed
    // when compound types are implemented.
    class Cat : 
        public Catalog {
    public:
        void traverse ( Introspector & ) const;
        void find ( const Ident & id, Viewer & ) const;
    };

    class Handler : 
        public HandlerAbstract < const Catalog > {
    public:
        Mutex & mutex ();
        ElementBlock < const Catalog > target ( const Guard & ) const;
        void release ( const Guard & );
    };

    Cat m_cat;
    RefCtr m_refCtr;
    OctetStreamSnipet m_octetStreamSnipet;
};


OctetStreamSnipet :: 
    OctetStreamSnipet ( PBuf :: Locker & locker, 
            size_t offset, size_t length )
    m_pSeg ( locker ),
    m_offset ( offset ),
    m_length ( length ),
    m_mutex ( locker ),
    m_pNext ( ??? );
{
}

Mutex & OctetStreamSnipet :: Handler :: 
    mutex ()
{
    return m_mutex;
}

ElementBlock < const epicsUInt8 > OctetStreamSnipet :: Handler :: 
    target ( const Guard & guard ) const
{
#error take advantage of Guard
}

void OctetStreamSnipet :: Handler :: 
    release ( const Guard & )
{
#error take advantage of Guard
    m_pSeg->release ();
}
