
/*
 *      OnceReq.h,v 1.8 2009/11/24 01:34:21 jhill Exp
 *
 *      Author  Jeffrey O. Hill
 *              johill@lanl.gov
 *              505 665 1831
 */

#error defunc ?

#ifndef OnceReqh
#define OnceReqh

#include <string>

#include "caSvrEvQue.h"

namespace ca {

// The m_responseNotify in this class isnt locked
// for accessing the event queue
class ResponderEventQueue :         
    public Responder {
public:
    void setResp ( PResp & );
    void clrResp ();
    class Handle : 
        public HandleIntf < Responder > {
    private:
        Responder & m_lock ();  
        Responder & m_lockRecursive ();  
        void m_unlock ();
        HandleIntf < Responder > & m_clone ();
        void m_release ();
        void m_show ( unsigned level ) const;
        RefCtr m_refCtr;
    };
private:
    PResp m_pResp;
    void m_responseNotify ( const PCat & );
    void m_show ( unsigned level ) const;
};

class OnceReq 
{
public:
    typedef EvQue :: Event Event;
    typedef EvQue :: Callback Callback;
    OnceReq ( CirSvr & );
    void initiate ( PReq &, PResp & );
    void initiate ( PReq &, PResp &, PCat & );
    void forceFailResponse ( const std :: string & failCtx );
    ~OnceReq (); 
    void cancel ( const char * pContext );
    void show ( unsigned level ) const; 
private:
    ResponderEventQueue m_responderEventQueue;
    ResponderEventQueue :: Handle m_handleResponderEventQueue;
    void m_requestCleanup ( const Guard & );
    void m_initiateFailHandler ( Guard &, const char * pContext );
    OnceReq ( const OnceReq & ); // disabled
    OnceReq & operator = ( const OnceReq & ); // disabled
};

} // end of namespace ca

#endif // ifndef OnceReqh

