
/*
 *
 *
 *                    L O S  A L A M O S
 *              Los Alamos National Laboratory
 *               Los Alamos, New Mexico 87545
 *
 *  Copyright, 1986, The Regents of the University of California.
 *
 *
 *	Author Jeffrey O. Hill
 *	johill@lanl.gov
 */

#include <algorithm>

#define epicsExportSharedSymbols
#include "caPtr.h"

using std :: min;

namespace ca {

void ignoredExceptMsg ( const type_info & handleType, 
    const char * pFuncName )
{
    errlogPrintf ( 
        "A non-standard C++ exception ocurred in "
        "\"%s\" :: %s ()\n",
        handleType.name (), pFuncName );
}

void ignoredExceptMsg ( const type_info & handleType, 
    const char * pFuncName, exception & except )
{
    errlogPrintf ( 
        "A C++ exception ocurred in "
        "\"%s\" :: %s (), type = \"%s\", ctx = \"%s\"\n",
        handleType.name (), pFuncName, 
        typeid ( except ).name (), except.what () );
}

#if 0

// appends to the StringEditor
size_t ByteVecPtrConst ::
    popString ( size_t maxElems, StringEditor & stringEditor )
{
    const size_t segLen = 
        std :: min ( this->nElem (), maxElems );
    size_t strLen = 0u;
    for ( ; strLen < segLen; strLen++ ) {
        if ( m_pTarget[strLen] == '\0' ) {
            break;
        }
    }
    if ( strLen ) {
        stringEditor.append ( 
            reinterpret_cast < const char * > ( m_pTarget ), strLen );
    }
    return strLen;
}

// returns the number of characters pushed
size_t ByteVecPtr :: 
    pushString ( const size_t beginPos, 
                    const StringReader & val )
{
    size_t len = val.size ();
    size_t pos = beginPos;
    if ( pos <= len ) {
        len -= pos;
        char * pTarget = 
            reinterpret_cast < char * > (
            const_cast < epicsUInt8 * > ( m_pTarget ) );
        size_t nElem = m_nElem;
        size_t nCpy = min ( nElem, len );
        while ( nCpy ) {
            size_t nActual = val.extract ( pos, pTarget, nCpy );
            if ( nActual > nCpy ) {
                throw std :: range_error ( 
                    "IterOut :: pushString: StringReader "
                    "copied more than requested?" );
            }
            pTarget += nActual;
            nElem -= nActual;
            len -= nActual;
            pos += nActual;
            size_t nCpy = min ( nElem, len );
        }
        if ( len == 0u && nElem > 0u ) {
            // add nill termination
            *pTarget++ = '\0';
            nElem--;
            pos++;
        }
        m_pTarget = reinterpret_cast 
                < epicsUInt8 * > ( pTarget );
        m_nElem = nElem;
    }   
    // this includes any nill termination being pushed
    return pos - beginPos;
}

size_t ByteVecPtr :: 
    pushZeros ( size_t len )
{
    char * pTarget = 
        reinterpret_cast < char * > (
        const_cast < epicsUInt8 * > ( m_pTarget ) );
    const size_t nCpy = min ( m_nElem, len );
    if ( nCpy > 0u ) {
        memset ( pTarget, '\0', nCpy );
        m_pTarget += nCpy;
        m_nElem -= nCpy;
    }
    return nCpy;
}
#endif

} // end of namespace ca
