/*************************************************************************\
* Copyright (c) 2002 The University of Chicago, as Operator of Argonne
*     National Laboratory.
* Copyright (c) 2002 The Regents of the University of California, as
*     Operator of Los Alamos National Laboratory.
* EPICS BASE Versions 3.13.7
* and higher are distributed subject to a Software License Agreement found
* in file LICENSE that is included with this distribution. 
\*************************************************************************/
/*
 *
 *      Author  Jeffrey O. Hill
 *              johill@lanl.gov
 *              505 665 1831
 */

#error defunct

#if 0

#include "legacyTypes.h"

using namespace ca;

ReadRequest :: 

static ReadRequest & ReadRequest :: factory ( 
    Guard & guard, 
    Channel & chan,
    const caHdrLargeArray & hdr )
{

    Request & req ( chan.createRequest (
        guard, readRequest, Type :: empty, 
        dbrToType ( hdr.m_dataType ), scb, fcb ) );
    Scb scb = 
        Scb :: factory < casChannelI, readSuccess > ( *this );
    Fcb fcb = 
        Fcb :: factory < casChannelI, readFail > ( *this );

#pragma message ( "implement free list" )
    return * new ReadRequest ( req, hdr );
}

typedef Method < Catalog > Scb;
typedef Method < Abberation > Fcb;

casChannelI :: ReadRequest :: ReadRequest (
    Guard &,
    Channel &,
    const caHdrLargeArray & )
@@@
    Guard & guard, 
    casChannelI & casChan, 
    const caHdrLargeArray & hdr, 
    PReadSuccess success, 
    PReadFail fail,
    Channel & chan ) :
    CoreRequest ( xxxx ),
    m_hdr ( hdr ),
    m_req ( chan.createRequest (
        guard, readRequest, Type :: empty, 
        dbrToType ( hdr.m_dataType ), 
        Scb :: factory < ReadRequest, success > ( *this ), 
        Fcb :: factory < ReadRequest, fail > ( *this ) ) ),
    m_success ( success ),
    m_fail ( fail )
{
}

casChannelI :: ReadRequest :: ~ ReadRequest ()
{
#pragma message ("should we send some failure response if IO is incomplete here")
}

void casChannelI :: ReadRequest :: success ( 
    Guard & guard, 
    const Catalog & respParms )
{
    ( m_chan.*m_success ) ( guard, *this, respParms );
}

void casChannelI :: ReadRequest :: failure ( 
    Guard & guard, 
    const Abberation & diag )
{
    ( m_chan.*m_fail ) ( guard, *this, diag );
}

#endif