


//
// VarLenStrRef.cpp,v 1.2 2009/11/24 01:34:22 jhill Exp
//
// Authors: Jeff Hill, johill@lanl.gov
//          Ralph Lange, Ralph.Lange@aps.anl.gov

#include <stdexcept>

#define epicsExportSharedSymbols
#include "VarLenStrRef.h"

VarLenStrRef :: VarLenStrRef (
    char * pBuf, size_t initialLength, 
	size_t capacity ) :
    m_pBuf ( pBuf ), m_len ( initialLength ),
	m_capacity ( capacity )
{
    if ( ! m_pBuf ) {
        throw std :: invalid_argument ( 
            "nill string pointer passed to String "
            "constructor" );
    }
    if ( m_len >= m_capacity ) {
        throw std :: invalid_argument ( 
            "invalid string length passed to String "
            "constructor" );
    }
}

size_t VarLenStrRef :: size () const 
{
    return m_len;
}

const char * VarLenStrRef :: getBuffer () const 
{
    return m_pBuf;
}

char * VarLenStrRef :: getBuffer ()
{
    return m_pBuf;
}
    
void VarLenStrRef :: setSize ( size_t len )
{
    if ( len >= m_capacity ) {
        throw std :: invalid_argument ( 
            "attempt to set length of String "
            "past the end of the buffer failed" );
    }
    m_len = len;
    m_pBuf [ len ] = '\0';
}

size_t VarLenStrRef :: capacity () const
{
    return m_capacity;
}

void VarLenStrRef :: reserve ( size_t cap )
{
    if ( cap > m_capacity ) {
        throw std :: invalid_argument ( 
            "attempt to set capacity of String failed" );
    }
}
