

/*
 *	Author Jeffrey O. Hill
 *	johill@lanl.gov
 */

#error defunct

#ifndef VecBytes_h
#define VecBytes_h

namespace ca {

struct VecBytes {
    VecBytes ();
    VecBytes ( epicsUInt8 * pVec, size_t nBytes );
    VecBytes ( const VecBytes &, size_t offset );
    size_t m_nBytes;
    epicsUInt8 * m_pVec;
};

inline VecBytes :: 
    VecBytes() : 
    m_pVec ( 0 ), m_nBytes ( 0 )
{
}

inline VecBytes :: 
    VecBytes ( const VecBytes & vb, size_t offset ) : 
    m_nBytes ( vb.m_nBytes > offset ? vb.m_nBytes - offset : 0 ),
    m_pVec ( m_nBytes ? vb.m_pVec + offset : 0 )
{
}

inline VecBytes :: 
    VecBytes ( epicsUInt8 * pVec, size_t nBytes ) : 
    m_pVec ( pVec ), m_nBytes ( nBytes )
{
}

} // end of namespace ca

#endif // ifndef VecBytesh
