
//
// Author: Jeff Hill, johill@lanl.gov
//

#error is this used?

#define epicsExportSharedSymbols
#include "dadbr.h"
#include "casdef2.h"

#if ! defined ( __GNUC__ ) || __GNUC__ > 2 || ( __GNUC__ == 2 && __GNUC_MINOR__ >= 95 )
namespace dadbr {
#endif

epicsShareFunc void assignDBR ( 
    unsigned dbrTypeOfDest, size_t nElem,
    void * pDest, const Catalog & src );

template < unsigned DBR_XXX >
static void assignScalar ( 
    void * pDest, const Catalog & src )
{
    Attr < DBR_XXX > :: Type Type;
    Type & dest ( * reinterpretCast < Type * > ( pDest ) );
    dadbr :: Attr < DBR_XXX > :: PropScalar prop ( dest );
    CatalogProxy < CatAtomic < Property < Type > > > cat ( prop );
    cat = src;
}

typedef void ( * PAssignFuncScalar ) ( 
    void * pDest, const Catalog & src );

static PAssignFuncScalar assignFuncScalar [] = {
    assignScalar < DBR_STRING >,
    assignScalar < DBR_INT >,
    assignScalar < DBR_SHORT >,	
    assignScalar < DBR_FLOAT >,	
    assignScalar < DBR_ENUM >,
    assignScalar < DBR_CHAR >,
    assignScalar < DBR_LONG >,
    assignScalar < DBR_DOUBLE >,
    assignScalar < DBR_STS_STRING >,
    assignScalar < DBR_STS_SHORT >,
    assignScalar < DBR_STS_INT >,	
    assignScalar < DBR_STS_FLOAT >,
    assignScalar < DBR_STS_ENUM >,
    assignScalar < DBR_STS_CHAR >,
    assignScalar < DBR_STS_LONG >,
    assignScalar < DBR_STS_DOUBLE >,
    assignScalar < DBR_TIME_STRING >,
    assignScalar < DBR_TIME_INT >,
    assignScalar < DBR_TIME_SHORT >,
    assignScalar < DBR_TIME_FLOAT >,
    assignScalar < DBR_TIME_ENUM >,
    assignScalar < DBR_TIME_CHAR >,
    assignScalar < DBR_TIME_LONG >,
    assignScalar < DBR_TIME_DOUBLE >,
    assignScalar < DBR_GR_STRING >,
    assignScalar < DBR_GR_SHORT >,
    assignScalar < DBR_GR_INT >,
    assignScalar < DBR_GR_FLOAT >,
    assignScalar < DBR_GR_ENUM >,
    assignScalar < DBR_GR_CHAR >,
    assignScalar < DBR_GR_LONG	>,
    assignScalar < DBR_GR_DOUBLE >,
    assignScalar < DBR_CTRL_STRING >,
    assignScalar < DBR_CTRL_SHORT >,
    assignScalar < DBR_CTRL_INT >,
    assignScalar < DBR_CTRL_FLOAT >,
    assignScalar < DBR_CTRL_ENUM >,
    assignScalar < DBR_CTRL_CHAR >,
    assignScalar < DBR_CTRL_LONG >,
    assignScalar < DBR_CTRL_DOUBLE >,
    assignScalar < DBR_PUT_ACKT >,
    assignScalar < DBR_PUT_ACKS >,
    assignScalar < DBR_STSACK_STRING >,
    assignScalar < DBR_CLASS_NAME >
};

static const unsigned assignFuncScalarNElem = 
    sizeof ( assignFuncScalar ) / sizeof ( assignFuncScalar[0] );

template < class T >
static void assignVector ( 
    size_t nElemOfDest, void * pDest, 
    const Catalog & src )
{
    T & dest ( * reinterpretCast < T * > ( pDest ) );
    Cat < T, Vector > cat ( dest, nElemOfDest );
    cat = src;
}

typedef void ( * PAssignFuncVector ) ( 
    size_t nElemOfDest, void * pDest, 
    const Catalog & src );

static PAssignFuncVector assignFuncVector [] = {
    assignVector < DBR_STRING >,
    assignVector < DBR_INT >,
    assignVector < DBR_SHORT >,	
    assignVector < DBR_FLOAT >,	
    assignVector < DBR_ENUM >,
    assignVector < DBR_CHAR >,
    assignVector < DBR_LONG >,
    assignVector < DBR_DOUBLE >,
    assignVector < DBR_STS_STRING >,
    assignVector < DBR_STS_SHORT >,
    assignVector < DBR_STS_INT >,	
    assignVector < DBR_STS_FLOAT >,
    assignVector < DBR_STS_ENUM >,
    assignVector < DBR_STS_CHAR >,
    assignVector < DBR_STS_LONG >,
    assignVector < DBR_STS_DOUBLE >,
    assignVector < DBR_TIME_STRING >,
    assignVector < DBR_TIME_INT >,
    assignVector < DBR_TIME_SHORT >,
    assignVector < DBR_TIME_FLOAT >,
    assignVector < DBR_TIME_ENUM >,
    assignVector < DBR_TIME_CHAR >,
    assignVector < DBR_TIME_LONG >,
    assignVector < DBR_TIME_DOUBLE >,
    assignVector < DBR_GR_STRING >,
    assignVector < DBR_GR_SHORT >,
    assignVector < DBR_GR_INT >,
    assignVector < DBR_GR_FLOAT >,
    assignVector < DBR_GR_ENUM >,
    assignVector < DBR_GR_CHAR >,
    assignVector < DBR_GR_LONG	>,
    assignVector < DBR_GR_DOUBLE >,
    assignVector < DBR_CTRL_STRING >,
    assignVector < DBR_CTRL_SHORT >,
    assignVector < DBR_CTRL_INT >,
    assignVector < DBR_CTRL_FLOAT >,
    assignVector < DBR_CTRL_ENUM >,
    assignVector < DBR_CTRL_CHAR >,
    assignVector < DBR_CTRL_LONG >,
    assignVector < DBR_CTRL_DOUBLE >,
    assignVector < DBR_PUT_ACKT >,
    assignVector < DBR_PUT_ACKS >,
    assignVector < DBR_STSACK_STRING >,
    assignVector < DBR_CLASS_NAME >
};

static const unsigned assignFuncVectorNElem = 
    sizeof ( assignFuncVector ) / sizeof ( assignFuncVector[0] );

void assignDBR ( 
    unsigned dbrTypeOfDest, unsigned nElemOfDest, 
    void * pDest, const Catalog & src )
{
    if ( nElemOfDest == 1 ) {
        if ( dbrTypeDest >= assignFuncScalarNElem ) {
            throw InvalidDataType ();
        }
        ( * assignFuncScalar [dbrTypeDest].pFunc ) 
            ( pDest, src );
    }
    else {
        if ( dbrTypeDest >= assignFuncVectorNElem ) {
            throw InvalidDataType ();
        }
        ( * assignFuncVector [dbrTypeDest].pFunc ) 
            ( nElemOfDest, pDest, src );
    }
}

#if ! defined ( __GNUC__ ) || __GNUC__ > 2 || ( __GNUC__ == 2 && __GNUC_MINOR__ >= 95 )
} // end of namespace dbdbr
#endif

