/*  
 *
 *                              
 *                    L O S  A L A M O S
 *              Los Alamos National Laboratory
 *               Los Alamos, New Mexico 87545
 *                                  
 *  Copyright, 1986, The Regents of the University of California.
 *                                  
 *           
 *	Author Jeffrey O. Hill
 *	johill@lanl.gov
 *	505 665 1831
 */

#define epicsExportSharedSymbols
#include "caAccessRights.h"

namespace ca {

Ident pi_readable ( "readable" );
Ident pi_writable ( "writable" );

AccessRights extractAccessRights ( const Catalog & cat )
{
    Clerk clerk ( cat );
    bool readable;
    bool writable;
    clerk.get ( pi_readable, readable, false );
    clerk.get ( pi_writable, writable, false );
    return AccessRights ( readable, writable );
}

} // end of namespace ca
