
#error defunct

#ifndef caCallbackh
#define caCallbackh

#include < exception >
#include < typeinfo >
#include < cstdio >

class Guard;

#if ! defined ( __GNUC__ ) || __GNUC__ > 2 || ( __GNUC__ == 2 && __GNUC_MINOR__ >= 95 )
namespace ca {
#endif

template < class P >
class Callback
{
public:
    void invoke ( Guard &, const P & ) throw ();
private:
    virtual void m_invoke ( Guard &, const P & ) = 0;
    static void m_exceptionInCBNotify ( std :: exception & );
    static void m_exceptionInCBNotify ();
};

template < class P, class T, 
    ( T :: * PCB )( Guard &, const P & ) >
class CallbackMembFunc :
    public Callback < P >
{
public:
    CallbackMembFunc ( T & );
private:
    void m_invoke ( Guard &, const P & );
    T & m_target;
};

template < class P >
void Callback < P > :: 
    m_exceptionInCBNotify ( std :: exception & except )
{
    std :: fprintf ( 
        std :: stderr,
        "Unexpected c++ exception \"%s\" "
        "orginiating in callback"\n",
        except.what () );
}

template < class P >
void Callback < P > :: 
    m_exceptionInCBNotify ()
{
    std :: fprintf ( 
        std :: stderr,
        "Unexpected c++ exception "
        "orginiating in callback\n" );
}

template < class P >
inline void Callback < P > :: invoke (
        Guard & guard, const P & parm ) throw ()
{
    // callbacks are m_not_ allowed to propagate
    // exceptions into their callers
    try {
        ( m_target .* PCB ) ( guard, parm );
    }
    catch ( std :: exception & except ) {
        m_exceptionInCBNotify ( except );
    }
    catch ( ... ) {
        m_exceptionInCBNotify ();
    }
}

template < class P, class T, 
    ( T :: * PCB )( Guard &, const P & ) >
inline CallbackMembFunc < T, P > :: 
    CallbackMembFunc ( T & target ) :
        m_target ( target )
{
}

template < class P, class T, 
    ( T :: * PCB )( Guard &, const P & ) >
void CallbackMembFunc < T, P, PCB > :: m_invoke (
        Guard & guard, const P & parm )
{
    ( m_target .* PCB ) ( guard, parm );
}

#if ! defined ( __GNUC__ ) || __GNUC__ > 2 || ( __GNUC__ == 2 && __GNUC_MINOR__ >= 95 )
} // end of namespace ca
#endif

#endif // ifndef caCallbackh

