
/*************************************************************************\
* Copyright (c) 2002 The University of Chicago, as Operator of Argonne
*     National Laboratory.
* Copyright (c) 2002 The Regents of the University of California, as
*     Operator of Los Alamos National Laboratory.
* EPICS BASE is distributed subject to a Software License Agreement found
* in file LICENSE that is included with this distribution. 
\*************************************************************************/

//
// Author: Jeff Hill
//

#define epicsExportSharedSymbols
#include "caIntfIO.h"

#pragma message ("maybe this file isnt needed")
namespace ca {

// CircuitTerminate :: CircuitTerminate () : std :: exception () {}
// CircuitTerminate :: ~CircuitTerminate () throw () {}

const char * CircuitTerminate :: what () const throw ()
{
    return "clean circuit termination";
}

CircuitDisconnect :: CircuitDisconnect ( const char * pCtx ) :
    m_reason ( pCtx )
{
}

const char * CircuitDisconnect :: what () const throw ()
{
    std :: string ctx;
    ctx += "abrupt circuit termination due to \"";
    ctx += m_reason;
    ctx += "\"";
    return ctx.c_str ();
}

} // end of namespace ca

