
/*************************************************************************\
* Copyright (c) 2002 The University of Chicago, as Operator of Argonne
*     National Laboratory.
* Copyright (c) 2002 The Regents of the University of California, as
*     Operator of Los Alamos National Laboratory.
* EPICS BASE Versions 3.13.7
* and higher are distributed subject to a Software License Agreement found
* in file LICENSE that is included with this distribution. 
\*************************************************************************/

#ifndef caServerh
#define caServerh

#ifdef epicsExportSharedSymbols
#   define epicsExportSharedSymbols_caServerh
#   undef epicsExportSharedSymbols
#endif

// external headers included here

#ifdef epicsExportSharedSymbols_caServerh
#   define epicsExportSharedSymbols
#   include "shareLib.h"
#endif

#include "caPtr.h"

namespace ca {

class Server;
typedef Ptr < Server > PServer;

class Server {
public:
	virtual unsigned getDebugLevel() const = 0;
	virtual void setDebugLevel ( unsigned debugLevelIn ) = 0;
    virtual void generateBeaconAnomaly () = 0;
	virtual void show ( unsigned level ) const = 0;
#if 0
    //void destroyMonitor ( casMonitor & );
	virtual EventMask valueEventMask () const = 0; 
	virtual EventMask logEventMask () const = 0;  
	virtual EventMask alarmEventMask () const = 0; 
    virtual unsigned subscriptionEventsProcessed () const = 0;
    virtual void incrEventsProcessedCounter () = 0;
    virtual unsigned subscriptionEventsPosted () const = 0;
    virtual void updateEventsPostedCounter ( unsigned nNewPosts ) = 0;
#endif
    //casMonitor & casMonitorFactory ( casChannelI &, 
    //    caResId clientId, const unsigned long count, 
    //    const unsigned type, const EventMask &, 
    //    class casMonitorCallbackInterface & );
    //void casMonitorDestroy ( casMonitor & );
    //void destroyClient ( Cir :: Svr & );
};

} // end of namespace ca

#endif // caServerh
