
/*************************************************************************\
* Copyright (c) 2002 The University of Chicago, as Operator of Argonne
*     National Laboratory.
* Copyright (c) 2002 The Regents of the University of California, as
*     Operator of Los Alamos National Laboratory.
* EPICS BASE Versions 3.13.7
* and higher are distributed subject to a Software License Agreement found
* in file LICENSE that is included with this distribution. 
\*************************************************************************/
/*
 *
 *
 *                    L O S  A L A M O S
 *              Los Alamos National Laboratory
 *               Los Alamos, New Mexico 87545
 *
 *  Copyright, 1986, The Regents of the University of California.
 *
 *
 *	Author Jeffrey O. Hill
 *	johill@lanl.gov
 */

#ifndef caStringReaderIterInh
#define caStringReaderIterInh

#ifdef epicsExportSharedSymbols
#   define epicsExportSharedSymbols_caStringReaderIterInh
#   undef epicsExportSharedSymbols
#endif

#include "BaseString.h"

#ifdef epicsExportSharedSymbols_caStringReaderIterInh
#   define epicsExportSharedSymbols
#   include "shareLib.h"
#endif

#include "IterInReader.h"

namespace ca {

class StringReaderIterIn : 
    public StringReader {
public:
    StringReaderIterIn ( IterIn &, size_t nBytes );
    size_t size () const;
    
    // Comparison functions
    bool equals(const StringReader & rhs) const;
    bool contains(size_t pos, const StringReader & rhs) const;
    bool contains(size_t pos, const char *buf, size_t len) const;
    
    // Indexed byte access
    char at(size_t pos) const;
    
    // Copy out to buffer, no terminator
    size_t extract(size_t pos, char *buf, size_t cap) const;
private:
    mutable IterInReader m_iterInReader;
};

inline StringReaderIterIn :: 
    StringReaderIterIn ( IterIn & iterIn, size_t nBytes ) :
    m_iterInReader ( iterIn, nBytes )
{
}

} // end of namespace ca

#endif // ifndef caStringReaderIterInh
