
/*
 *	Author Jeffrey O. Hill
 *	johill@lanl.gov
 */

#define epicsExportSharedSymbols
#include "caSvrCirMgrChanHdrOnly.h"
#include "caSvrCirMgrFreeLists.h"

namespace ca {
namespace Svr {
namespace Cir {

PResp Mgr :: Chan :: HdrOnly ::
        factory ( Mgr & mgr, const HdrLargeArray & hdr )
{
    HdrOnly * pHdrOnly = new ( mgr.m_pFreeLists->m_hdrOnly ) 
                            HdrOnly ( mgr, hdr );
    return PResp ( pHdrOnly->m_eventQueueRespHandle );
}

/////////////////////////////////////////////////
// M_EventQueueRespHandle
/////////////////////////////////////////////////
Mgr :: Chan :: HdrOnly :: M_EventQueueRespHandle :: M_EnclLnk
    Mgr :: Chan :: HdrOnly :: M_EventQueueRespHandle ::  
        m_enclLnk ( & HdrOnly :: m_eventQueueRespHandle );
Mgr :: Chan :: HdrOnly :: M_EventQueueRespHandle :: TargetMutexPair 
    Mgr :: Chan :: HdrOnly :: M_EventQueueRespHandle ::
        m_targetMutexPair ()
{
    HdrOnly & hdrOnly ( m_enclLnk.enclosure ( *this ) );
    return TargetMutexPair ( hdrOnly.m_eventQueueResponder, 
                                 hdrOnly.m_mgr.m_noopMutex );
}
HandleIntf < Responder > & 
    Mgr :: Chan :: HdrOnly :: M_EventQueueRespHandle ::
        m_clone ()
{
    HdrOnly & hdrOnly ( m_enclLnk.enclosure ( *this ) );
    hdrOnly.m_refCtr.reference ();
    return *this;
}
void Mgr :: Chan :: HdrOnly :: M_EventQueueRespHandle ::
        m_release ()
{
    HdrOnly & hdrOnly ( m_enclLnk.enclosure ( *this ) );
    if ( hdrOnly.m_refCtr.unreference () ) {
        Guard guard ( hdrOnly.m_mgr.m_mutex );
        hdrOnly.m_mgr.m_pFreeLists->
            m_hdrOnly.deleteProduct ( hdrOnly );
        // no code below here considering above destroy
    }
    // no code below here considering above destroy
}

} // end of namespace Cir
} // end of namespace Svr
} // end of namespace ca
