
#ifndef caSvrCirMgrChanHdrOnlyh
#define caSvrCirMgrChanHdrOnlyh

#ifdef epicsExportSharedSymbols
#   define epicsExportSharedSymbols_caSvrCirMgrChanHdrOnlyh
#   undef epicsExportSharedSymbols
#endif

#include "EnclLnk.h"

#ifdef epicsExportSharedSymbols_caSvrCirMgrChanHdrOnlyh
#   define epicsExportSharedSymbols
#   include "shareLib.h"
#endif

#include "caSvrCirMgrChan.h"
#include "caSvrCirRspThrHdrOnly.h"

namespace ca {
namespace Svr {
namespace Cir {

class Mgr :: Chan :: HdrOnly 
{
public:
    static PResp factory ( Mgr &, const HdrLargeArray & );
    HdrOnly ( Mgr &, const HdrLargeArray & );
private:
    class M_EventQueueRespHandle : 
        public HandleIntf < Responder > {
    private:
		TargetMutexPair m_targetMutexPair ();
		HandleIntf < Responder > & m_clone ();
		void m_release ();
        typedef const epics :: EnclLnk < HdrOnly, 
                    M_EventQueueRespHandle > M_EnclLnk;
        static M_EnclLnk m_enclLnk;
    };
    RspThr :: HdrOnly m_eventQueueResponder;
    M_EventQueueRespHandle m_eventQueueRespHandle;
    Mgr & m_mgr;
    RefCtr m_refCtr;
    HdrOnly ( const HdrOnly & ); 
    HdrOnly & operator = ( const HdrOnly & ); 
};

inline Mgr :: Chan :: HdrOnly ::
    HdrOnly ( Mgr & mgr, const HdrLargeArray & respMsg ) :
    m_eventQueueResponder ( respMsg ), m_mgr ( mgr )
{
    // We dont need to reserve space on the event queue
    // because the event add occurs in the receive thread
    // where we can easily deal with errors. It harder
    // for example to deal with event queue add errors 
    // in the response callback from the service.
}

} // end of namespace Cir
} // end of namespace Svr
} // end of namespace ca

#endif // caSvrCirMgrChanHdrOnlyh
