
#ifndef caSvrCirMgrChanReadh
#define caSvrCirMgrChanReadh

#ifdef epicsExportSharedSymbols
#   define epicsExportSharedSymbols_caSvrCirMgrChanReadh
#   undef epicsExportSharedSymbols
#endif

#include "EnclLnk.h"

#ifdef epicsExportSharedSymbols_caSvrCirMgrChanReadh
#   define epicsExportSharedSymbols
#   include "shareLib.h"
#endif

#include "caSvrCirMgrChan.h"
#include "caSvrCirRspThrRead.h"

namespace ca {
namespace Svr {
namespace Cir {

class Mgr :: Chan :: Read 
{
public:
    static PResp factory ( Chan &, const PReq &, 
        const HdrLargeArray &, caResId cid );
    Read ( Chan &, const PReq &, 
        const HdrLargeArray &, caResId cid );
    ~Read ();
    void show ( unsigned level ) const;
private:
    class M_Responder :         
        public Responder {
    private:
        void m_responseNotify ( const PCat & );
        void m_show ( unsigned ) const;
        typedef const epics :: EnclLnk < Read, M_Responder > M_EnclLnk;
        static M_EnclLnk m_enclLnk;
    };
    class M_EQRespHandle : 
        public HandleIntf < Responder > {
    private:
		TargetMutexPair m_targetMutexPair ();
		HandleIntf < Responder > & m_clone ();
		void m_release ();
        typedef const epics :: EnclLnk < Read, M_EQRespHandle > M_EnclLnk;
        static M_EnclLnk m_enclLnk;
    };
    class M_ServRespHandle : 
        public HandleIntf < Responder > {
    private:
		TargetMutexPair m_targetMutexPair ();
		HandleIntf < Responder > & m_clone ();
		void m_release ();
        typedef const epics :: EnclLnk < Read, M_ServRespHandle > M_EnclLnk;
        static M_EnclLnk m_enclLnk;
    };
    class M_ReqNotify :
        public ReqNotify {
    public:
        void show ( unsigned level ) const;
        bool subscrDestroy ( caResId );
        void readLackingCallbackDestroy ();
        void enterFlowControlMode ();
        void exitFlowControlMode ();
        void channelDestroyNotify ();
    private:
        typedef const epics :: EnclLnk < Read, M_ReqNotify > M_EnclLnk;
        static M_EnclLnk m_enclLnk;
    };
    RspThr :: Read m_rspThrRead;
    M_EQRespHandle m_eqRespHandle;
    M_ServRespHandle m_servRespHandle;
    M_Responder m_responder;
    M_ReqNotify m_reqNotify;
    // We keep a reference to the request until 
    // this object is destroyed. Its anti-social 
    // to destroy the request when we are in the 
    // service's call to the response callback.
    PReq m_pReq;
    // this is set to nill when this object is 
    // removed from the channel's list of IO
    // Requests
    Chan * m_pChan;
    // we cache a ref to the Mgr so that we
    // can still lock after the channel ptr
    // is set to nill when the IO completes
    // or the channel is destroyed
    Mgr & m_mgr;
    RefCtr m_refCtr;
    void m_ioCancel ( const char *pCtx );
    void m_sharedRelease ();
    Read ( const Read & ); // disabled
    Read & operator = ( const Read & ); // disabled
};

} // end of namespace Cir
} // end of namespace Svr
} // end of namespace ca

#endif // ifndef caSvrCirMgrChanReadh
