
/*
 *	Author Jeffrey O. Hill
 *	johill@lanl.gov
 */

#ifndef caSvrCirMgrFreeListsh
#define caSvrCirMgrFreeListsh

#ifdef epicsExportSharedSymbols
#   define epicsExportSharedSymbols_caSvrCirMgrFreeListsh
#   undef epicsExportSharedSymbols
#endif

#include "tsFreeList.h"

#ifdef epicsExportSharedSymbols_caSvrCirMgrFreeListsh
#   define epicsExportSharedSymbols
#   include "shareLib.h"
#endif

#include "caSvrCirMgrChan.h"
#include "caSvrCirMgrChanRead.h"
#include "caSvrCirMgrChanWrite.h"
#include "caSvrCirMgrChanSubscribe.h"
#include "caSvrCirMgrChanCircMon.h"
#include "caSvrCirMgrChanHdrOnly.h"
#if 0
#include "caSvrCirMgrChanChanCreate.h"
#endif

namespace ca {
namespace Svr {
namespace Cir {

// cant forward ref Chan :: Req before Chan is defined so
// this goes in a satellite struct
struct Mgr :: FreeLists {
    void show ( unsigned level ) const;

    tsFreeList < Chan > m_chan;
    //tsFreeList < Chan :: ChanCreate > m_chanCreate;

    tsFreeList < Chan :: Read > m_chanRead;
    tsFreeList < Chan :: Write > m_chanWrite;
    tsFreeList < Chan :: CircMon > m_chanCircMon;
    tsFreeList < Chan :: Subscribe > m_chanSubscribe;
    tsFreeList < Chan :: HdrOnly > m_hdrOnly;

    //tsFreeList < Chan :: ChanDelete, 256 > m_chanDelete;
    //tsFreeList < RspThr :: BadMsgLen, 256 > m_badMsgLen;
};

} // end of namespace Cir
} // end of namespace Svr
} // end of namespace ca

#endif // caSvrCirMgrFreeListsh
