
#ifndef caSvrCirRspThrCirMonh
#define caSvrCirRspThrCirMonh

#ifdef epicsExportSharedSymbols
#   define epicsExportSharedSymbols_caSvrCirRspThrCirMonh
#   undef epicsExportSharedSymbols
#endif

#ifdef epicsExportSharedSymbols_caSvrCirRspThrCirMonh
#   define epicsExportSharedSymbols
#   include "shareLib.h"
#endif

#include "caSvrCirRspThr.h"

namespace ca {
namespace Svr {
namespace Cir {

class RspThr :: CircMon : 
    public Responder {
public:
    CircMon ( caResId sid, caResId cid );
private:
    caResId m_sid;
    caResId m_cid;
    bool m_createChannelRespWasSent;
    //bool m_attachResponseHasBeenSent;
    //bool m_disconnectResponseHasBeenSent;
    //bool m_createChannelRespWasSent;
    void m_responseNotify ( const PCat & );
    void m_show ( unsigned ) const;
    void m_unresponsiveNotify ( const PCat & );
    void m_responsiveNotify ( const PCat & );
    void m_disconnectNotify ( const PCat & );
    typedef void ( CircMon :: * PStateNotifyFunc ) 
                                    ( const PCat & );
    static const PStateNotifyFunc m_stateNotifyDispatch [3];
    //static PType m_pSubscrReqType;
    //static PType m_pSubscrResType;
    CircMon ( const CircMon & ); // not implemented
    CircMon & operator = ( const CircMon & ); // not implemented
    //
    // Circuit State Notify Strategy
    // -----------------------------
    // o For clients at V4.12 or higher send the channel create
    // response immediately, and dont wait for the service to 
    // inform us that the channel is responsive. For before 
    // V4.12 postpone sending the create channel response until 
    // only after channel becomes responsive for the first time. 
    // o Never send the "server deletes PV" response when when 
    // service notifies the server that the channel is disconnected. 
    // The client library will nevertheless need to continue to 
    // continue to support this feature for some time due to the 
    // legacy portable server code (in the gateway).
    // o If we are unable to allocate memory for the channel then
    // send the CA_PROTO_CREATE_CH_FAIL response. Otherwise,
    // if the channel disconnects after we create send the
    // CA_PROTO_CH_CONN_STATE response to V4.12 clients, and if its
    // an old client rudely disconnect them at the TCP level.
    //
    // With this strategy we guarantee that the MEDM screen will
    // always go to disconnected white in response to a gateway 
    // loss of service as the users will demand. 
    //
};

} // end of namespace Cir
} // end of namespace Svr
} // end of namespace ca

#endif // caSvrCirRspThrCirMonh
