
/*
 *	Author Jeffrey O. Hill
 *	johill@lanl.gov
 */

#define epicsExportSharedSymbols
#include "caSvrCirRspThrHdrOnly.h"
#include "protoDiagnostics.h"
#include "v3Proto.h"

namespace ca {
namespace Svr {
namespace Cir {

void RspThr :: HdrOnly :: 
    m_responseNotify ( const PCat & )
{
    RspThr * pRspThr = RspThr :: pAttachedRspThr ();
    MsgMinderV3 msgMinderV3 ( pRspThr->m_byteSeqOut,
        pRspThr->m_minorVersionNumber );
    msgMinderV3.pushResp ( m_responseMsg );
    msgMinderV3.commit ();
}

void RspThr :: HdrOnly :: 
    m_show ( unsigned level ) const
{
    printf ( "ca::Svr::Cir::RspThr::HdrOnly\n" );
    if ( level > 0 ) {
        dumpMsg ( m_responseMsg );
    }
}

} // end of namespace Cir
} // end of namespace Svr
} // end of namespace ca
