
#ifndef caSvrCirRspThrHdrOnlyh
#define caSvrCirRspThrHdrOnlyh

#ifdef epicsExportSharedSymbols
#   define epicsExportSharedSymbols_caSvrCirRspThrHdrOnlyh
#   undef epicsExportSharedSymbols
#endif

#include "epicsThread.h"
#include "epicsTime.h"

#ifdef epicsExportSharedSymbols_caSvrCirRspThrh
#   define epicsExportSharedSymbols
#   include "shareLib.h"
#endif

#include "caHdrLargeArray.h" 
#include "caSvrCirRspThr.h" 

namespace ca {
namespace Svr {
namespace Cir {

class RspThr :: HdrOnly : 
    public Responder
{
public:
    HdrOnly ( const HdrLargeArray & );
private:
    // the constructor forces the postsize field in this 
    // header to be zero
    HdrLargeArray m_responseMsg;
    void m_responseNotify ( const PCat & );
    void m_show ( unsigned ) const;
    HdrOnly ( const HdrOnly & ); // disabled
    HdrOnly & operator = ( const HdrOnly & ); // disabled
};

inline RspThr :: HdrOnly :: 
    HdrOnly ( const HdrLargeArray & responseMsg ) :
    m_responseMsg ( responseMsg )
{
}

} // end of namespace Cir
} // end of namespace Svr
} // end of namespace ca

#endif // ifndef caSvrCirRspThrHdrOnlyh
