
#ifndef caSvrCirRspThrSubscribeh
#define caSvrCirRspThrSubscribeh

#ifdef epicsExportSharedSymbols
#   define epicsExportSharedSymbols_caSvrCirRspThrSubscribeh
#   undef epicsExportSharedSymbols
#endif

#ifdef epicsExportSharedSymbols_caSvrCirRspThrSubscribeh
#   define epicsExportSharedSymbols
#   include "shareLib.h"
#endif

#include "caSvrCirRspThr.h"
#include "caHdrLargeArray.h" 

namespace ca {
namespace Svr {
namespace Cir {

// this is m_not_ in the CirSvr lock domain
class RspThr :: Subscribe : 
    public Responder
{
public:
    Subscribe ( const HdrLargeArray &, caResId cid );
    caResId clientId () const;
private:
    class ResponseAgentSuccess :
        public MutatorCatalog {
    public:
        ResponseAgentSuccess ( Subscribe &, 
                    const Catalog & respParms );
        void assignDefault ();
        void assignScalarCatalog ( const Catalog & src );
    private:
        Subscribe & m_subscribe;
        const Catalog & m_respParms;
    };
    class ResponseAgentFailure :
        public MutatorCatalog {
    public:
        ResponseAgentFailure ( Subscribe & );
        void assignDefault ();
        void assignScalarCatalog ( const Catalog & src );
    private:
        Subscribe & m_subscribe;
    };
    HdrLargeArray m_reqMsg;
    caResId m_cid;
    void m_responseNotify ( const PCat & );
    void m_show ( unsigned ) const;
    void m_failResponse ( const Catalog & );
    Subscribe ( const Subscribe & ); // disabled
    Subscribe & operator = ( const Subscribe & ); // disabled
};

inline caResId RspThr :: Subscribe :: clientId () const
{
    return m_cid;
}

} // end of namespace Cir
} // end of namespace Svr
} // end of namespace ca

#endif // caSvrCirRspThrSubscribeh
