

#ifndef caSvrCirRspThrWriteh
#define caSvrCirRspThrWriteh

#ifdef epicsExportSharedSymbols
#   define epicsExportSharedSymbols_caSvrCirRspThrWriteh
#   undef epicsExportSharedSymbols
#endif

#ifdef epicsExportSharedSymbols_caSvrCirRspThrWriteh
#   define epicsExportSharedSymbols
#   include "shareLib.h"
#endif

#include "caSvrCirRspThr.h"
#include "caHdrLargeArray.h" 

namespace ca {
namespace Svr {
namespace Cir {

class RspThr :: Write : public Responder
{
public:
    Write ( const HdrLargeArray &, caResId cid );
    ~Write ();
private:
    class ResponseAgentSuccess :
        public MutatorCatalog {
    public:
        ResponseAgentSuccess ( RspThr :: Write &, 
                            const Catalog & respParms );
        void assignDefault ();
        void assignScalarCatalog ( const Catalog & src );
    private:
        RspThr :: Write & m_write;
        const Catalog & m_respParms;
    };
    class ResponseAgentFailure :
        public MutatorCatalog {
    public:
        ResponseAgentFailure ( RspThr :: Write & );
        void assignDefault ();
        void assignScalarCatalog ( const Catalog & src );
    private:
        RspThr :: Write & m_write;
    };
    const HdrLargeArray m_reqMsg;
    const caResId m_cid;
    void m_responseNotify ( const PCat & );
    void m_show ( unsigned ) const;
    void m_failResponse ( const Catalog & failureContext );
    Write ( const Write & ); // disabled
    Write & operator = ( const Write & ); // disabled
};

} // end of namespace Cir
} // end of namespace Svr
} // end of namespace ca

#endif // caSvrCirRspThrWriteh
