/*************************************************************************\
* Copyright (c) 2002 The University of Chicago, as Operator of Argonne
*     National Laboratory.
* Copyright (c) 2002 The Regents of the University of California, as
*     Operator of Los Alamos National Laboratory.
* EPICS BASE Versions 3.13.7
* and higher are distributed subject to a Software License Agreement found
* in file LICENSE that is included with this distribution. 
\*************************************************************************/

#ifndef caSvrDGRspThrBeaconAnomGovh
#define caSvrDGRspThrBeaconAnomGovh

#ifdef epicsExportSharedSymbols
#   define epicsExportSharedSymbols_caSvrDGRspThrBeaconAnomGovh
#   undef epicsExportSharedSymbols
#endif

#include "EnclLnk.h"

#ifdef epicsExportSharedSymbols_caSvrDGRspThrBeaconAnomGovh
#   define epicsExportSharedSymbols
#   include "shareLib.h"
#endif

#include "caSvrDGMgr.h"

class epicsTime;
class epicsTimer;
class epicsTimerQueue;
template < typename > class Ptr;

namespace ca {
namespace Svr {
namespace DG {

class Mgr :: BeaconAnomGov {
public:
    BeaconAnomGov ( Mgr &, epicsTimerQueue & );
    ~BeaconAnomGov ();
    void start ();
    void show ( unsigned level ) const;
private:
    class M_TimerNotify :
        public epicsTimerNotify {
    public:
        expireStatus expire ( const epicsTime & currentTime );
        void show ( unsigned ) const;
    private:
        typedef const epics :: EnclLnk < BeaconAnomGov, 
                                    M_TimerNotify > M_EnclLnk;
        static M_EnclLnk m_enclLnk;
    };
    M_TimerNotify m_timerNotify;
    Mgr & m_mgr;
    epicsTimer & m_timer;
    bool m_anomalyPending;
};

} // end of namespace DG
} // end of namespace Svr
} // end of namespace ca

#endif // ifndef caSvrDGRspThrBeaconAnomGovh