
/*************************************************************************\
* Copyright (c) 2002 The University of Chicago, as Operator of Argonne
*     National Laboratory.
* Copyright (c) 2002 The Regents of the University of California, as
*     Operator of Los Alamos National Laboratory.
* EPICS BASE Versions 3.13.7
* and higher are distributed subject to a Software License Agreement found
* in file LICENSE that is included with this distribution. 
\*************************************************************************/
/*
 *      caSvrDGRspThrBeacon.cpp,v 1.3 2009/11/24 01:34:25 jhill Exp
 *
 *      Author  Jeffrey O. Hill
 *              johill@lanl.gov
 *              505 665 1831
 */

#if 0
#include "fdManager.h"
#endif

#include "envDefs.h"
#include "errlog.h"

#define epicsExportSharedSymbols
#if 0
#include "caServer.h"
#endif
#include "caSvrDGMgrBeaconTimer.h"

namespace ca {
namespace Svr {
namespace DG {

RspThr :: Beacon :: 
    Beacon () : m_beaconCounter ( 0u )
{
}

void RspThr :: Beacon ::
    m_responseNotify ( const PCat & )	
{
    RspThr * pRspThr = RspThr :: pAttachedRspThr ();
    if ( pRspThr ) {
        m_beaconCounter++;
        pRspThr->m_pDatagramOut->sendBeacon ( m_beaconCounter );
    }
}

void RspThr :: Beacon :: 
    m_show ( unsigned level ) const
{
    printf ( "RspThr :: Beacon\n" );
    if ( level > 0u ) {
        printf ( "m_beaconCounter = %u\n", m_beaconCounter );
    }
}

//
// (implemented here because this has knowledge of the protocol)
//
#if 0
epicsTimerNotify :: expireStatus 
    RspThr :: BeaconTimer :: Notify ::
        expire ( const epicsTime & currentTime )
{
    BeaconTimer & beaconTimer ( target () );
	union {
		caHdr	msg;
		char	buf;
	};

	//
	// create the message
	//
	memset ( & buf, 0, sizeof ( msg ) );
    AlignedWireRef < epicsUInt16 > 
        ( msg.m_cmmd ) = CA_PROTO_RSRV_IS_UP;
    AlignedWireRef < epicsUInt16 > 
        ( msg.m_dataType ) = CA_MINOR_PROTOCOL_REVISION;
    AlignedWireRef < epicsUInt32 > 
        ( msg.m_cid ) = beaconTimer.m_beaconCounter++;

	//
	// send it to all addresses on the beacon list,
    // but let the IO specific code set the address
    // field and the port field
	//
	this->sendBeaconIO ( buf, sizeof ( msg ), msg.m_count, msg.m_available );
}
#endif

} // end of namespace DG
} // end of namespace Svr
} // end of namespace ca
