
/*************************************************************************\
* Copyright (c) 2002 The University of Chicago, as Operator of Argonne
*     National Laboratory.
* Copyright (c) 2002 The Regents of the University of California, as
*     Operator of Los Alamos National Laboratory.
* EPICS BASE Versions 3.13.7
* and higher are distributed subject to a Software License Agreement found
* in file LICENSE that is included with this distribution. 
\*************************************************************************/

#ifndef caSvrDGRspThrBeaconh
#define caSvrDGRspThrBeaconh

#ifdef epicsExportSharedSymbols
#   define epicsExportSharedSymbols_caSvrDGRspThrBeaconh
#   undef epicsExportSharedSymbols
#endif

#ifdef epicsExportSharedSymbols_caSvrDGRspThrBeaconh
#   define epicsExportSharedSymbols
#   include "shareLib.h"
#endif

#include "caSvrDGRspThr.h"

namespace ca {
namespace Svr {
namespace DG {

class RspThr :: Beacon : 
    public Responder {
public:
    Beacon ();
private:
    ca_uint32_t m_beaconCounter;
    void m_responseNotify ( const PCat & );
    void m_show ( unsigned ) const;
    Beacon ( const Beacon & );
    Beacon & operator = ( const Beacon & );
};

} // end of namespace DG
} // end of namespace Svr
} // end of namespace ca

#endif // ifndef caSvrDGRspThrBeaconh
