/*************************************************************************\
* Copyright (c) 2002 The University of Chicago, as Operator of Argonne
*     National Laboratory.
* Copyright (c) 2002 The Regents of the University of California, as
*     Operator of Los Alamos National Laboratory.
* EPICS BASE Versions 3.13.7
* and higher are distributed subject to a Software License Agreement found
* in file LICENSE that is included with this distribution. 
\*************************************************************************/

#ifndef caSvrDGRspThrDGCoalescerh
#define caSvrDGRspThrDGCoalescerh

#ifdef epicsExportSharedSymbols
#   define epicsExportSharedSymbols_caSvrDGRspThrDGCoalescerh
#   undef epicsExportSharedSymbols
#endif


#ifdef epicsExportSharedSymbols_caSvrDGRspThrDGCoalescerh
#   define epicsExportSharedSymbols
#   include "shareLib.h"
#endif

#include "caSvrDGRspThr.h"
#include "DGParm.h"
#include "ByteSeqOut.h"

namespace ca {
namespace Svr {
namespace DG {

// this class determines if we will start a new datagram
// o if the next messsage is to large to fit because the 
// current frame is used up
// o if the DGParm reference passed in doesnt match the
// m_currentDGParm cached in the class
class RspThr :: DGCoalescer {
public:
    DGCoalescer ( RspThr &, const Ptr < VecAllocator > & );
    ~DGCoalescer ();
    void pushHeader ( DGParm &, const caHdr & );
    void pushHeaderAndRev ( DGParm &, const caHdr & );
    void flush ();
    void show ( unsigned level ) const;
    static RspThr * pAttachedRspThr ();
private:
    DGParm m_currentDGParm;
    ByteSeqOut m_byteSeqOut;
    RspThr & m_rspThr;
    typedef ByteSeqOut :: Iter Iter;
    void m_pushHeader ( Iter &, const caHdr & );
    void m_pushDGHeader ();
    void m_flushOnDemand ( DGParm &, size_t msgSize );
};

} // end of namespace DG
} // end of namespace Svr
} // end of namespace ca

#endif // ifndef caSvrDGRspThrDGCoalescerh
