/*************************************************************************\
* Copyright (c) 2002 The University of Chicago, as Operator of Argonne
*     National Laboratory.
* Copyright (c) 2002 The Regents of the University of California, as
*     Operator of Los Alamos National Laboratory.
* EPICS BASE Versions 3.13.7
* and higher are distributed subject to a Software License Agreement found
* in file LICENSE that is included with this distribution. 
\*************************************************************************/

#ifndef caSvrDGRspThrDatagramOutWriterh
#define caSvrDGRspThrDatagramOutWriterh

#ifdef epicsExportSharedSymbols
#   define epicsExportSharedSymbols_caSvrDGRspThrDatagramOutWriterh
#   undef epicsExportSharedSymbols
#endif

#ifdef epicsExportSharedSymbols_caSvrDGRspThrDatagramOutWriterh
#   define epicsExportSharedSymbols
#   include "shareLib.h"
#endif

#include "caSvrDGRspThr.h"
#include "caIntfIO.h"

namespace ca {

struct DatagramOut;

namespace Svr {
namespace DG {

class RspThr :: DatagramOutWriter :
    public Writer {
public:
    DatagramOutWriter ( DatagramOut & );
    void write ( const Vec < const epicsUInt8 > & );
private:
    DatagramOut & m_datagramOut;
};

inline RspThr :: DatagramOutWriter ::
    DatagramOutWriter ( DatagramOut & datagramOut ) :
    m_datagramOut ( datagramOut )
{
}

} // end of namespace DG
} // end of namespace Svr
} // end of namespace ca

#endif // ifndef caSvrDGRspThrDatagramOutWriterh