
/*************************************************************************\
* Copyright (c) 2002 The University of Chicago, as Operator of Argonne
*     National Laboratory.
* Copyright (c) 2002 The Regents of the University of California, as
*     Operator of Los Alamos National Laboratory.
* EPICS BASE Versions 3.13.7
* and higher are distributed subject to a Software License Agreement found
* in file LICENSE that is included with this distribution. 
\*************************************************************************/

#ifndef caSvrDGRspThrNameResh
#define caSvrDGRspThrNameResh

#ifdef epicsExportSharedSymbols
#   define epicsExportSharedSymbols_caSvrDGRspThrNameResh
#   undef epicsExportSharedSymbols
#endif

#include "caProto.h"

#ifdef epicsExportSharedSymbols_caSvrDGRspThrNameResh
#   define epicsExportSharedSymbols
#   include "shareLib.h"
#endif

#include "caSvrDGRspThr.h"
#include "DGParm.h"

namespace ca {
namespace Svr {
namespace DG {

class RspThr :: NameRes : 
    public Responder {
public:
    NameRes ( const DGParm &, caResId cid, bool failRespRequired );
private:
    class ResponseAgentSuccess :
        public MutatorCatalog {
    public:
        ResponseAgentSuccess ( NameRes &, const Catalog & respParms );
        void assignDefault ();
        void assignScalarCatalog ( const Catalog & src );
    private:
        NameRes & m_nameRes;
        const Catalog & m_respParm;
    };
    class ResponseAgentFailure :
        public MutatorCatalog {
    public:
        ResponseAgentFailure ( NameRes & );
        void assignDefault ();
        void assignScalarCatalog ( const Catalog & src );
    private:
        NameRes & m_nameRes;
    };
    DGParm m_dgParm;
    caResId m_cid;
    bool m_failRespRequired;
    void m_responseNotify ( const PCat & );
    void m_show ( unsigned ) const;
    void m_failResponse ( const Catalog & );
    NameRes ( const NameRes & ); // disabled
    NameRes & operator = ( const NameRes & ); // disabled
};

} // end of namespace DG
} // end of namespace Svr
} // end of namespace ca

#endif // ifndef caSvrDGRspThrNameResh
