
#define epicsExportSharedSymbols
#include "caSvrEvQueFailResp.h"

namespace ca {

Ident pi_failure ( "failure" );

namespace Svr {

EvQue :: FailResp :: 
    FailResp ( EvQue & eventQueue,
        const char * pCtxString ) :
    m_catalog ( pCtxString ),
    m_evQue ( eventQueue )
{
}

PCat EvQue :: FailResp ::
    createPtr ()
{
    return PCat ( m_handle );
}

/////////////////////////////////////////////////////
// handle for fail response payload
/////////////////////////////////////////////////////
EvQue :: FailResp :: M_Handle :: M_EnclLnk
    EvQue :: FailResp :: M_Handle ::  
        m_enclLnk ( & FailResp :: m_handle );
HandleIntf < const Catalog > :: TargetMutexPair    
    EvQue :: FailResp :: M_Handle :: 
        m_targetMutexPair ()
{
    FailResp & failResp ( m_enclLnk.enclosure ( *this ) );
    return TargetMutexPair ( failResp.m_catalog, 
            failResp.m_evQue.m_noopMutex );
}
HandleIntf < const Catalog > &
    EvQue :: FailResp :: M_Handle :: 
        m_clone ()
{
    FailResp & failResp ( m_enclLnk.enclosure ( *this ) );
    failResp.m_refCtr.reference ();
    return *this;
}
void EvQue :: FailResp :: M_Handle ::
    m_release ()
{
    FailResp & failResp ( m_enclLnk.enclosure ( *this ) );
    if ( failResp.m_refCtr.unreference () ) {
        Guard guard ( failResp.m_evQue.m_mutex );
        failResp.m_evQue.m_failRespFreeList.deleteProduct ( failResp );
        // no code after above delete
    }
    // no code after above delete
}

EvQue :: FailResp :: M_Catalog ::
    M_Catalog ( const char * pCtxString ) :
    m_failureContext ( pCtxString )
{
}

void EvQue :: FailResp :: M_Catalog ::
    traverse ( Introspector & introspector ) const
{
    introspector.reveal ( pi_failure, m_failureContext );
}

void EvQue :: FailResp :: M_Catalog ::
    find ( const Ident & id, Viewer & viewer ) const
{
    if ( id == pi_failure ) {
        viewer.reveal ( m_failureContext );
    }
}

} // end of namepace Svr
} // end of namespace ca
