
/*************************************************************************\
* Copyright (c) 2002 The University of Chicago, as Operator of Argonne
*     National Laboratory.
* Copyright (c) 2002 The Regents of the University of California, as
*     Operator of Los Alamos National Laboratory.
* EPICS BASE Versions 3.13.7
* and higher are distributed subject to a Software License Agreement found
* in file LICENSE that is included with this distribution. 
\*************************************************************************/

// Author: Jeff HIll

#ifndef caSvrEvQueFailResph
#define caSvrEvQueFailResph

#ifdef epicsExportSharedSymbols
#   define epicsExportSharedSymbols_caSvrEvQueFailResph
#   undef epicsExportSharedSymbols
#endif

#include "EnclLnk.h"

#ifdef epicsExportSharedSymbols_caSvrEvQueFailResph
#   define epicsExportSharedSymbols
#   include "shareLib.h"
#endif

#include "caSvrEvQue.h"
#include "FailureContext.h"

namespace ca {
namespace Svr {

class EvQue :: FailResp 
{
public:
    FailResp ( EvQue &, const char * pCtxString );
    PCat createPtr ();
private:
    class M_Catalog : 
        public Catalog {
    public:
        M_Catalog ( const char * pCtxString );
        void traverse ( Introspector & ) const;
        void find ( const Ident &, Viewer & ) const;
    private:
        FailureContext m_failureContext;
    };
    class M_Handle : 
        public HandleIntf < const Catalog > {
    private:
		TargetMutexPair m_targetMutexPair ();
		HandleIntf < const Catalog > & m_clone ();
		void m_release ();
        typedef const epics :: EnclLnk < FailResp, 
                                M_Handle > M_EnclLnk;
        static M_EnclLnk m_enclLnk;
    };
    M_Catalog m_catalog;
    M_Handle m_handle;
    RefCtr m_refCtr;
    EvQue & m_evQue;
    FailResp ( const FailResp & );
    FailResp & operator = ( FailResp & );
};


} // end of namesapce Svr
} // end of namespace ca

#endif // ifndef caSvrEvQueFailResph

