
//
// Author: Jeff Hill, johill@lanl.gov
//

#ifndef cadbrCatCmpdScalar_h
#define cadbrCatCmpdScalar_h

#include "shareLib.h"

namespace ca {
namespace dbr {

template < class F >
class CatCmpdScalar :
    public Catalog
{
public:
    typedef typename F :: DBR DBR;
    CatCmpdScalar ( const DBR & );
    void traverse ( Introspector & ) const;
    void find ( const Ident & id, Viewer & ) const;
private:
    const DBR & m_dbr;
    F m_catFacets;
};

template < class F >
inline CatCmpdScalar < F > ::
    CatCmpdScalar ( const DBR & dbr ) : 
    m_dbr ( dbr ), m_catFacets ( dbr )
{
}

template < class F >
void CatCmpdScalar < F > ::
    traverse ( Introspector & i ) const
{
    reveal ( i, pi_value, m_dbr.value, m_catFacets );
}

template < class F >
void CatCmpdScalar < F > ::
    find ( const Ident & id, Viewer & v ) const
{
    if ( id == pi_value ) {
        reveal ( v, m_dbr.value, m_catFacets );
    }
}

} // end of namespace dbr
} // end of namespace ca

#endif // ifdef cadbrCatCmpdScalar_h
