

//
// Author: Jeff Hill, johill@lanl.gov
//

#ifndef cadbrCatCmpdVector_h
#define cadbrCatCmpdVector_h

namespace ca {
namespace dbr {

template < class S >
class CatCmpdVector :
    public Catalog
{
public:
    typedef typename S :: DBR DBR;
    CatCmpdVector ( const DBR &, size_t nElem );
    void traverse ( Introspector & ) const;
    void find ( const Ident & id, Viewer & ) const;
    void assign ( const Catalog & );
private:
    const DBR & m_dbr;
    S m_catSubord;
    size_t m_nElem;
};

template < class S >
inline CatCmpdVector < S > ::
    CatCmpdVector ( const DBR & dbr, size_t nElem ) : 
    m_dbr ( dbr ), m_catSubord ( dbr ), 
        m_nElem ( nElem )
{
}

template < class S >
void CatCmpdVector < S > ::
    traverse ( Introspector & i ) const
{
    reveal ( i, pi_value, & m_dbr.value, 
                    m_nElem, m_catSubord );
}

template < class S >
void CatCmpdVector < S > ::
    find ( const Ident & id, Viewer & v ) const
{
    if ( id == pi_value ) {
        reveal ( v, & m_dbr.value, 
                m_nElem, m_catSubord );
    }
}

template < class S >
void CatCmpdVector < S > ::
    assign ( const Catalog & src )
{
    get ( src, pi_value, & m_dbr.value, 
                    m_nElem, m_catSubord );
}

} // end of namespace dbr
} // end of namespace ca

#endif // ifdef cadbrCatCmpdVector_h
