
#error defunct

//
// cadbrIntfScalarCompoundDBR.h,v 1.2 2009/11/24 01:34:28 jhill Exp
//
// Authors: Jeff Hill, johill@lanl.gov
//         

#ifndef cadbrIntfScalarCompoundDBR_h
#define cadbrIntfScalarCompoundDBR_h

#ifdef epicsExportSharedSymbols
#undef epicsExportSharedSymbols
#define epicsExportSharedSymbolsRestore_cadbrIntfScalarCompoundDBR
#endif

#include "daStringInFixedLenCharArray.h"

#ifdef epicsExportSharedSymbolsRestore_cadbrIntfScalarCompoundDBR
#define epicsExportSharedSymbols
#endif

#include "shareLib.h"

namespace ca {
namespace dbr {

template < class T > 
class IntfScalarCompoundDBR :
    public Catalog {
public:
    typedef T Type;
    IntfScalarCompoundDBR ( T &, Catalog & sub );
    void traverse ( Introspector & ) const;
    void find ( const Ident & id, Viewer & ) const;
    void assign ( const Catalog & );
private:
    T & m_dbr;
    Catalog & m_sub;
    template < class V >
    void m_assign ( V & dest, const Catalog & );
};

template < class T > 
class IntfScalarStringCompoundDBR :
    public Catalog {
public:
    typedef T Type;
    IntfScalarStringCompoundDBR ( T &, Catalog & sub );
    void traverse ( Introspector & ) const;
    void find ( const Ident & id, Viewer & ) const;
    void assign ( const Catalog & );
private:
    T & m_dbr;
    Catalog & m_sub;
};

template < class T >
inline IntfScalarCompoundDBR < T > ::
    IntfScalarCompoundDBR ( 
        T & dbr, Catalog & sub ) : 
        m_dbr ( dbr ), m_sub ( sub )
{
}

template < class T >
void IntfScalarCompoundDBR < T > :: 
    traverse ( Introspector & introspector ) const
{
    introspector.reveal ( pi_value, m_dbr.value, m_sub );
}

template < class T >
void IntfScalarCompoundDBR < T > :: 
    find ( const Ident & id, Viewer & viewer ) const
{
    if ( id == pi_value ) {
        viewer.reveal ( m_dbr.value, m_sub );
    }
}

template < class T >
template < class V >
inline void IntfScalarCompoundDBR < T > ::
    m_assign ( V & dest, const Catalog & src )
{
    PropertyNodeAssignerRef < V > 
        propertyAssignerNode ( dest, m_sub );
    src.get ( pi_value, propertyAssignerNode );
}

template < class T >
void IntfScalarCompoundDBR < T > :: 
     assign ( const Catalog & src )
{
    m_assign ( m_dbr.value, src );
}

template < class T >
inline IntfScalarStringCompoundDBR < T > ::
    IntfScalarStringCompoundDBR ( 
        T & dbr, Catalog & sub ) : 
        m_dbr ( dbr ), m_sub ( sub )
{
}

template < class T >
void IntfScalarStringCompoundDBR < T > :: 
    traverse ( Introspector & introspector ) const
{
    static const size_t STRLEN = 
        sizeof ( m_dbr.value ) / sizeof ( m_dbr.value[0] );
    using namespace StringInFixedLenCharArray;
    ScalarIntfConst < STRLEN > scalarIntfConst ( m_dbr.value );
    introspector.reveal ( pi_value, scalarIntfConst, m_sub );
}

template < class T >
void IntfScalarStringCompoundDBR < T > :: 
    find ( const Ident & id, Viewer & viewer ) const
{
    static const size_t STRLEN = 
        sizeof ( m_dbr.value ) / sizeof ( m_dbr.value[0] );
    using namespace StringInFixedLenCharArray;
    if ( id == pi_value ) {
        ScalarIntfConst < STRLEN > scalarIntfConst ( m_dbr.value );
        viewer.reveal ( scalarIntfConst, m_sub );
    }
}

template < class T >
void IntfScalarStringCompoundDBR < T > :: 
     assign ( const Catalog & src )
{
    static const size_t STRLEN = 
        sizeof ( m_dbr.value ) / sizeof ( m_dbr.value[0] );
    using namespace StringInFixedLenCharArray;
    ScalarIntf < STRLEN > scalarIntf ( m_dbr.value );
    PropertyNodeAssignerRef < StringEditor > 
        propertyAssignerNode ( scalarIntf, m_sub );
    src.get ( pi_value, propertyAssignerNode );
}

} // end of namespace dbr
} // end of namespace ca

#endif // ifdef cadbrIntfScalarCompoundDBR_h

