
//
// cadbrIntfVectorCompoundDBR.h,v 1.2 2009/11/24 01:34:28 jhill Exp
//
// Authors: Jeff Hill, johill@lanl.gov
//     

#error defunct

#ifndef cadbrIntfVectorCompoundDBR_h
#define cadbrIntfVectorCompoundDBR_h

namespace ca {
namespace dbr {

template < class T > 
class IntfVectorCompoundDBR :
    public Catalog {
public:
    typedef typename T :: DBR DBR;
    typedef typename T :: CatSubord CatSubord;
    typedef typename T :: Assigner Assigner;
    IntfVectorCompoundDBR ( DBR &, Array & );
    void traverse ( Introspector & ) const;
    void find ( const Ident & id, Viewer & ) const;
    void assign ( const Catalog & );
private:
    DBR & m_dbr;
    Array & m_array;
};

template < class SUB >
inline IntfVectorCompoundDBR < SUB > ::
    IntfVectorCompoundDBR ( 
        DBR & dbr, Array & arrayIn ) : 
    m_dbr ( dbr ), m_array ( arrayIn )
{
}

template < class SUB >
inline void IntfVectorCompoundDBR < SUB > :: 
    traverse ( Introspector & introspector ) const
{
    introspector.reveal ( pi_value, 
        m_array, CatSubord ( m_dbr ) );
}

template < class SUB >
inline void IntfVectorCompoundDBR < SUB > :: 
    find ( const Ident & id, Viewer & viewer ) const
{
    if ( id == pi_value ) {
        viewer.reveal ( m_array, 
            CatSubord ( m_dbr ) );
    }
}

template < class SUB >
inline void IntfVectorCompoundDBR < SUB > :: 
     assign ( const Catalog & src )
{
    src.get ( pi_value, Assigner ( m_dbr ) );
}

} // end of namespace dbr
} // end of namespace ca

#endif // ifdef cadbrIntfVectorCompoundDBR_h

