
//
// Author: Jeff Hill, johill@lanl.gov
//

#ifndef cadbrMutCmpdVector_h
#define cadbrMutCmpdVector_h

namespace ca {
namespace dbr {

template < class M >
class MutCmpdVector : 
    public Mutator {
public:
    typedef typename M :: DBR DBR;
    MutCmpdVector ( DBR &, size_t nElem );
    void assignDefault ();
    void assignNexus ( const Catalog & facets );
    void assignAtomic ( const Atomic & val, 
                        const Catalog & facets );
    void assignCatalog ( const Catalog & val );
private:
    M m_mutFacets;
    DBR & m_dbr;
    size_t m_nElem;
};

template < class M >
inline MutCmpdVector < M > ::
    MutCmpdVector ( DBR & dbr, size_t nElem ) :
    m_mutFacets ( dbr ), m_dbr ( dbr ), m_nElem ( nElem )
{
}

template < class M >
void MutCmpdVector < M > ::
    assignDefault ()
{
    throw UndefinedProperty ();
}

template < class M >
void MutCmpdVector < M > ::
    assignNexus ( const Catalog & /* facets */ )
{
    throw UndefinedProperty ();
}

template < class M >
void MutCmpdVector < M > ::
    assignAtomic ( const Atomic & src, const Catalog & srcFacets )
{
    // this interface doesngt need to be virtual
    m_mutFacets.assignCatalog ( srcFacets );
    get ( src, &m_dbr.value, m_nElem );
}

template < class M >
void MutCmpdVector < M > ::
    assignCatalog ( const Catalog & src )
{
    throw IncompatibleTypes ( typeid ( DBR ), typeid ( src ) );
}

} // end of namespace dbr
} // end of namespace ca

#endif // ifdef cadbrMutCmpdVector_h
