


//
// Author: Jeff Hill
//

#ifndef caTypeRegistry_h
#define caTypeRegistry_h

#if ! defined ( __GNUC__ ) || __GNUC__ > 2 || ( __GNUC__ == 2 && __GNUC_MINOR__ >= 95 )
namespace ca {
#endif

struct TypeRegistry {
    class Type {
    public:
        virtual void findDefault ( const Ident &, Viewer & ) = 0;
        virtual void traverse ( Surveyor & ) = 0;
    };
    virtual class Registration & createTypeRegistration (
        epicsGuard &, const Inventory &,
        const Catalog & defaults = Catalog :: empty ) = 0;
    virtual void destroyTypeRegistration ( 
        epicsGuard &, Registration & ) = 0; 
};

#if ! defined ( __GNUC__ ) || __GNUC__ > 2 || ( __GNUC__ == 2 && __GNUC_MINOR__ >= 95 )
} // end of namespace ca
#endif

#endif // ifndef caTypeRegistry_h
