
/*************************************************************************\
* Copyright (c) 2002 The University of Chicago, as Operator of Argonne
*     National Laboratory.
* Copyright (c) 2002 The Regents of the University of California, as
*     Operator of Los Alamos National Laboratory.
* EPICS BASE Versions 3.13.7
* and higher are distributed subject to a Software License Agreement found
* in file LICENSE that is included with this distribution. 
\*************************************************************************/
//
// casDGIntfIO.h,v 1.4 2009/10/23 21:47:45 jhill Exp
//

#error defunct ?

#ifndef casDGIntfIOh
#define casDGIntfIOh

#include "casStreamIO.h"
#include "ipIgnoreEntry.h"

class casDGIntfIO : 
    public StreamIO {
public:
	casDGIntfIO (  
        const caNetAddr & addr, 
        bool autoBeaconAddr = true, 
        bool addConfigBeaconAddr = false );
    ~casDGIntfIO () {}
	void sendBeacon ( 
        char & msg, size_t length, 
        aitUint16 &portField, aitUint32 & addrField );
	void osdSend ( 
        const char * pBuf, size_t nBytesReq );
	size_t osdRecv ( 
        char * pBuf, size_t bufSize );
	virtual void show ( unsigned level ) const;

	static size_t optimumOutBufferSize ();
	static size_t optimumInBufferSize ();

    size_t incomingBytesPresent () const;

private:
    tsFreeList < ipIgnoreEntry, 128 > ipIgnoreEntryFreeList;
    resTable < ipIgnoreEntry, ipIgnoreEntry > ignoreTable;
	ELLLIST beaconAddrList;
	SOCKET sock;
#pragma message("must have a special receive thread for this guy")
	SOCKET bcastRecvSock; // fix for solaris bug
	SOCKET beaconSock; // allow connect
	unsigned short dgPort;

    static SOCKET makeSockDG ();
	casDGIntfIO ( const casDGIntfIO & );
	casDGIntfIO & operator = ( const casDGIntfIO & );
};

inline int casDGIntfIO::getBCastFD() const
{
	return this->bcastRecvSock;
}

inline bool casDGIntfIO::validBCastFD() const
{
	return this->bcastRecvSock != INVALID_SOCKET;
}

#endif // casDGIntfIOh

