

/*************************************************************************\
* Copyright (c) 2002 The University of Chicago, as Operator of Argonne
*     National Laboratory.
* Copyright (c) 2002 The Regents of the University of California, as
*     Operator of Los Alamos National Laboratory.
* EPICS BASE Versions 3.13.7
* and higher are distributed subject to a Software License Agreement found
* in file LICENSE that is included with this distribution. 
\*************************************************************************/
//
// ipIgnoreEntry.h,v 1.2 2009/09/04 23:18:16 jhill Exp
//

#ifndef ipIgnoreEntryh
#define ipIgnoreEntryh

#ifdef epicsExportSharedSymbols
#   define epicsExportSharedSymbols_ipIgnoreEntryh
#   undef epicsExportSharedSymbols
#endif

#include "tsSLList.h"
#include "tsFreeList.h"
#include "resourceLib.h"

#ifdef epicsExportSharedSymbols_ipIgnoreEntryh
#   define epicsExportSharedSymbols
#   include "shareLib.h"
#endif

class ipIgnoreEntry : public tsSLNode < ipIgnoreEntry > {
public:
    ipIgnoreEntry ( unsigned ipAddr );
    void show ( unsigned level ) const;
    bool operator == ( const ipIgnoreEntry & ) const;
    resTableIndex hash () const;
private:
    unsigned ipAddr;
	ipIgnoreEntry ( const ipIgnoreEntry & );
	ipIgnoreEntry & operator = ( const ipIgnoreEntry & );
};

#endif // ipIgnoreEntryh

