
/*************************************************************************\
* Copyright (c) 2002 The University of Chicago, as Operator of Argonne
*     National Laboratory.
* Copyright (c) 2002 The Regents of the University of California, as
*     Operator of Los Alamos National Laboratory.
* EPICS BASE Versions 3.13.7
* and higher are distributed subject to a Software License Agreement found
* in file LICENSE that is included with this distribution. 
\*************************************************************************/
//
// sockStreamIO.h,v 1.3 2009/11/24 01:34:46 jhill Exp
//

#error defunct ?

#ifndef sockStreamIOh
#define sockStreamIOh

#include "casStreamIO.h"

struct ioArgsToNewStreamIO {
	caNetAddr addr;
	SOCKET sock;
};

class sockStreamIO : 
    public StreamIO {
public:
	sockStreamIO ( caServerI &, clientBufMemoryManager &, 
        const ioArgsToNewStreamIO & );
	~sockStreamIO ();
    const caNetAddr getAddr() const;
	void hostName ( char *pBuf, unsigned bufSize ) const;
    void forceDisconnect ();
	size_t incomingBytesPresent() const;
	static size_t optimumBufferSize ();
	void osdShow ( unsigned level ) const;
	casStreamWriteIO::flushCondition osdSend ( const char *pBuf, size_t nBytesReq, 
		size_t & nBytesActual );
	casStreamReadIO::fillCondition osdRecv ( char *pBuf, size_t nBytesReq, 
		size_t & nBytesActual );
private:
	SOCKET m_sock;
	struct sockaddr_in m_addr;
    bool m_sockHasBeenShutdown;
	sockStreamIO ( const sockStreamIO & );
	sockStreamIO & operator = ( const sockStreamIO & );
};

#endif // sockStreamIOh
