/*************************************************************************\
* Copyright (c) 2008 UChicago Argonne LLC, as Operator of Argonne
*     National Laboratory.
* EPICS BASE is distributed subject to the Software License Agreement
* in the file LICENSE that is included with this distribution.
\*************************************************************************/
//	Author: Andrew Johnson

// ChunkedString.cpp

#include <cassert>
#include <stdexcept>

#define epicsExportSharedSymbols
#include "ChunkedString.h"

// Virtual methods for base class to use
bool ChunkedString::getSegment(const char *&buf, size_t &len, size_t pos) const {
    return buf_.getSegment(buf, len, pos);
}
bool ChunkedString::getSegment(char *&buf, size_t &len, size_t pos) {
    return buf_.getSegment(buf, len, pos);
}
void ChunkedString::setSize(size_t len) {
    assert(buf_.capacity() >= len);
    len_ = len;
}


// Constructor
ChunkedString::ChunkedString(const char *buf, size_t len) :
    buf_(len), len_(0) {
    if (!buf) throw std::invalid_argument("FIXME");
    if (!len) len = strlen(buf);
    assign(buf, len);
}

