/*************************************************************************\
* Copyright (c) 2002 The University of Chicago, as Operator of Argonne
*     National Laboratory.
* Copyright (c) 2002 The Regents of the University of California, as
*     Operator of Los Alamos National Laboratory.
* EPICS BASE Versions 3.13.7
* and higher are distributed subject to a Software License Agreement found
* in file LICENSE that is included with this distribution. 
\*************************************************************************/

/*
 *	epicsThrowTrace.cpp,v 1.1 2003/05/30 00:51:49 jhill Exp
 *
 *  Author: Jeff Hill
 */

#define epicsExportSharedSymbols
#include "errlog.h"
#include "epicsThrowTrace.h"

bool epicsThrowTraceEnable = false;

void epicsShareAPI epicsThrowLocTrace ( 
    const char * pFileName, unsigned lineNo ) 
{
    if ( epicsThrowTraceEnable ) {
        errlogPrintf ( "C++ exception thrown in %s at line %d\n", 
            pFileName, lineNo );
    }
}

