/*************************************************************************\
* Copyright (c) 2002 The University of Chicago, as Operator of Argonne
*     National Laboratory.
* Copyright (c) 2002 The Regents of the University of California, as
*     Operator of Los Alamos National Laboratory.
* EPICS BASE Versions 3.13.7
* and higher are distributed subject to a Software License Agreement found
* in file LICENSE that is included with this distribution. 
\*************************************************************************/

/*  
 *  ipAddrToAsciiAsynchronous.h,v 1.15 2009/09/04 22:47:03 jhill Exp
 *
 *                              
 *                    L O S  A L A M O S
 *              Los Alamos National Laboratory
 *               Los Alamos, New Mexico 87545
 *                                  
 *  Copyright, 1986, The Regents of the University of California.
 *                                  
 *           
 *	Author Jeffrey O. Hill
 *	johill@lanl.gov
 */

#ifndef ipAddrToAsciiAsynchronous_h
#define ipAddrToAsciiAsynchronous_h

#include "osiSock.h"
#include "shareLib.h"

class epicsShareClass ipAddrToAsciiCallBack {
public:
    virtual ~ipAddrToAsciiCallBack () {} 
    virtual void transactionComplete ( const char * pHostName ) = 0;
    virtual void show ( unsigned level ) const;
};

class ipAddrToAsciiTransaction { 
public:
    virtual void ipAddrToAscii ( 
        const osiSockAddr &, ipAddrToAsciiCallBack & ) = 0;
    virtual osiSockAddr address () const  = 0;
    virtual void show ( unsigned level ) const = 0; 
    virtual void destroy () = 0;
protected:
    virtual ~ipAddrToAsciiTransaction () {} // disabled, use destroy
};

class ipAddrToAsciiEngine { 
public:
    virtual ipAddrToAsciiTransaction & createTransaction () = 0;
    virtual void show ( unsigned level ) const = 0; 
    virtual void destroy () = 0;
    epicsShareFunc static ipAddrToAsciiEngine & create ();
protected:
    virtual ~ipAddrToAsciiEngine () {} // disabled, use destroy
};

#endif // ifdef ipAddrToAsciiAsynchronous_h
