/*************************************************************************\
* Copyright (c) 2007 UChicago Argonne LLC, as Operator of Argonne
*     National Laboratory.
* Copyright (c) 2002 The Regents of the University of California, as
*     Operator of Los Alamos National Laboratory.
* EPICS BASE is distributed subject to a Software License Agreement found
* in file LICENSE that is included with this distribution. 
\*************************************************************************/

/*
 *                    L O S  A L A M O S
 *              Los Alamos National Laboratory
 *               Los Alamos, New Mexico 87545
 *
 *  Author Jeffrey O. Hill
 *  johill@lanl.gov
 */

#ifndef osdAtomic
#define osdAtomic

#include <climits>

#include "osdAtomicGCC.h"

#ifndef gccStdLibCxxAtomicIsPresent

#include <atomic.h>

namespace epics {
namespace osi {

// works only on Solaris 10

typedef uint_t AtomicWord;

inline AtomicWord atomicIncr ( AtomicWord & target )
{
    return atomic_inc_uint_nv ( & target );
}

inline AtomicWord atomicDecr ( AtomicWord & target )
{
    return atomic_dec_uint_nv ( & target );
}

inline void atomicSet ( AtomicWord & target, AtomicWord newVal )
{
    atomic_swap_uint ( & target, newVal );
}

inline AtomicWord atomicFetch ( const AtomicWord & target )
{
    return atomic_add_int_nv ( const_cast < size_t * > ( & target ), 0 );
}

inline bool atomicTestAndSet ( epicsUInt32 & target )
{
    return atomic_cas_uint ( & target, 0, 1 ) == 0;
}

} // end of namespace osi
} // endof namespace epics

#endif // ifndef gccStdLibCxxAtomicIsPresent

#endif // osdAtomic
