/*************************************************************************\
* Copyright (c) 2007 UChicago Argonne LLC, as Operator of Argonne
*     National Laboratory.
* Copyright (c) 2002 The Regents of the University of California, as
*     Operator of Los Alamos National Laboratory.
* EPICS BASE is distributed subject to a Software License Agreement found
* in file LICENSE that is included with this distribution. 
\*************************************************************************/

/*
 *                    L O S  A L A M O S
 *              Los Alamos National Laboratory
 *               Los Alamos, New Mexico 87545
 *
 *  Author Jeffrey O. Hill
 *  johill@lanl.gov
 */

#ifndef osiAtomic
#define osiAtomic

#include "epicsTypes.h"
#include "shareLib.h"

#include "osdAtomic.h"

namespace epics {

namespace osi {

// sync target in cache, add one to target, flush target in cache, 
// return new value of target
epicsShareFunc AtomicWord atomicIncr ( AtomicWord & target );
// sync target in cache, subtract one from target, flush target in cache, 
// return new value of target
epicsShareFunc AtomicWord atomicDecr ( AtomicWord & target );
// set target in cache, sync cache
epicsShareFunc void atomicSet ( const AtomicWord & target, AtomicWord newValue );
// sync target in cache, return new value of target
epicsShareFunc AtomicWord atomicFetch ( const AtomicWord & target );
// sync target in cache, if target is zero set target to non-zero (true) value, 
// flush target in cache, return true if this request changed the target from
// a zero value to a non-zero (true) value
epicsShareFunc bool atomicTestAndSet ( AtomicWord & target );

} // end of namespace osi

} // end of namespace epics

#endif // osiAtomic
